{   LZHUF.C English version 1.0
    Based on Japanese version 29-NOV-1988
    LZSS coded by Haruhiko OKUMURA
    Adaptive Huffman Coding coded by Haruyasu YOSHIZAKI
    Edited and translated to English by Kenji RIKITAKE
    Converted to Turbo Pascal 5.0 by Peter Sawatzki with assistance of Wayne Sullivan
    Ported to the Atari ST/TT and assembler optimization by Joe Jared of 1:125/1212@Fidonet.Org
}
{$A-,D-,E+,R-,P-,S20}
program LZH_Test;
{$I AUXSUBS}
{$I GEMSUBS}
Const
    HCEVer = '0.25g';
{Dos constants}
    readonly    = $1;
    hidden      = $2;
    Sysfile     = $4;
    volumeid    = $8;
    directory   = $10;
    Archive     = $20;
    anyfile     = $3f;
{------------------------}

type

{Dos Typecasts}
    fn_range = 1..14 ;
    fname = PACKED ARRAY [ fn_range ] OF char ;
    searchrec = PACKED RECORD
                reserved : PACKED ARRAY [ 0..19 ] OF byte ;
                resvd2 : byte ;
                attrib : byte ;
                time_stamp : integer ;
                date_stamp : integer ;
                filesize : long_integer ;
                name : fname ;
                END ;

    pathname = PACKED ARRAY [ 1..80 ] OF char ;
{-------------------------------------------------------------------}


    word    =   integer; 
    LongInt =   Long_Integer;
    IObuf   =   array [0..4095] of byte; { With Personal Pascal, this is word aligned data so the buffer will be twice as large }
var

    main_screen :Screen_Type;
    ginitok : Integer;
    count: LongInt;
    encoding        : Boolean;
    Mwindow,
    h1,m1,s1,h2,m2,s2 : Short_integer;
    t1,t2,t3            : Long_Integer;

    ptr_array   : Array [0..30] of Long_Integer;
    ibufPtr,                      
    obufptr             : Long_Integer;
    inptr,
    inend,
    outptr,
    outend              : Word;
    {Dos variables}
    sr : searchrec ;
    i : fn_range ;
    defpath,name    : Path_name;
    path : pathname ;
    {--------------------------}


    infile,outfile: file of byte;
    ibuf,obuf: IObuf;
    s,st1,st2,st3: String;
    selected_mode:  short_integer;
    textsize: LongInt;
    codesize: LongInt;
    IOR : Integer; {see dos}



    lzrec   : Long_Integer;
{Dos procedures and functions}
 
 PROCEDURE set_dta( VAR buf : searchrec ) ;
    GEMDOS( $1a ) ;

  FUNCTION findfirst( VAR path : pathname ; search_attrib :integer ):integer ;
    GEMDOS( $4e ) ;


  procedure Error (msg: String);
  begin
    writeln(msg);
    HALT;
  end;

function readbuf (rbHand:short_integer;
                    count:Long_Integer;
                    var buf:IoBUF):Long_Integer;
                    gemdos($3f);
procedure R2BUFFER;
var RCount  : Word;
  begin
    inptr:= 0;
        If Encoding then write (#13,textsize);
        
        inend := readbuf(handle(infile),sizeof(ibuf),ibuf);
    if Io_Result>0 then Error('! Error reading input file');
  end;

Function WriteBuff(Handle: Short_Integer;
                    Count: Long_Integer;
                    Var Buf: IOBUF) : Long_Integer;
        GEMDOS($40);

  procedure WFBUFFER;
  var
    wr: word;
  begin
        If not Encoding then write(#13,Count);
        wr := WriteBuff(Handle(OutFile), outptr,obuf);
    if (Io_Result>0) or (wr<outptr) then
      Error('! Error writing output file');
    outptr:= 0;
  end;

  procedure OpenInput (fn: String);
var ir : Word;
  begin
    FOR ir := 1 TO length( fn ) DO
      path[ir] := fn[ir] ;
    path[ length(fn)+1 ] := chr(0) ;
    set_Dta (sr);   {Setup for findfirst}
    ior := Findfirst(path,anyfile);
    reset(infile,fn);
    seek (infile,0);
    if Io_Result>0 then Error('! Can''t open input file');
    R2Buffer;
  end;

  procedure OpenOutput (fn: String);
  begin
    rewrite(outfile,fn);
    seek(outfile,0);
    if Io_Result>0 then Error('! Can''t open output file');
    outend := sizeof(obuf);
    outptr:= 0;
  end;
procedure Encode (bytes: LongInt);external;
procedure Decode;external;
procedure SETLZMEM(
                    var     cnt: Longint;
                    var     l:Long_Integer ); External;
procedure oops;
begin
    if ginitok <> -1 then begin
        close_Window(Mwindow);
        delete_Window(Mwindow);
        exit_gem;
        end; 
    halt;
end;  

{----------------------------------------------}{----------------------------------------------}
begin
    (*  First, we need to setup the pointers to Ibuf, obuf, and other associated variables... 
        Special application note:
        Due to the fact that Personal Pascal can't seem to come up with a strongly typecast structure of either
        forward or backwards reference, each common variable has to be pointed to... sigh 
        Notes on Ptr_Array[7]:
        Personal Pascal variables are all word aligned, which makes true byte access impossible at the assembly
        language level.  Since the bytes are stored hi..lo, you need to grab the "next" byte for true access
        at the byte level.
    *)
        Ptr_Array[0]    := addr_Long_Integer(Ptr_Array[0]); {self}
        Ptr_Array[1]    := addr_byte(Ibuf[0]) ;
        Ptr_Array[2]    := addr_byte(obuf[0]) ;
        Ptr_Array[3]    := addr_Integer(inptr);
        Ptr_Array[4]    := addr_Integer(inend);
        Ptr_Array[5]    := addr_Integer(outptr); 
        Ptr_Array[6]    := addr_Integer(outend);
        Ptr_Array[7]    := addr_Long_Integer(codesize);
        Ptr_Array[8]    := addr_Long_Integer(textsize);
        Ptr_Array[9]    := addr_Long_Integer(count);
    Setlzmem(count,Ptr_Array[0]);
    if cmd_args = 3 then begin
    writeln ('Huffman Compression Engine v',HCEVer);
        cmd_getArg(1,st1);
        cmd_getArg(2,st2);
        cmd_getArg(3,st3);
        end
    else begin
            ginitok := Init_Gem; if ginitok = -1 then halt;
            hide_mouse;
            save_scrn(main_screen);
            clear_Screen;
            s := 'Huffman Compression Engine v';
            s := concat(s,HCEVer);
            Mwindow := new_window (G_name,s,0,0,0,0);
            open_Window(Mwindow,0,0,0,0);
            show_mouse;
            selected_mode := do_alert ('[0][Select mode of operation:][ Encode | Decode  | Cancel] ',1);
            case selected_mode of
                1   : st1 := 'e';
                2   : st1 := 'd';
                3   : oops;
                end;    {case}              
            if not get_in_file(defpath,st2) then oops;
            if not get_out_file ('Please enter a filename for output',st3) then oops;
            writeln ('lz ',st1,' ',st2,' ',st3);
            end;
    OpenInput(st2);
    OpenOutput(st3);
    
    Get_Time (h1,m1,s1);
    case st1[1] of
        'e','E':    begin
                         {-write size of original text}
                        writeln (#13,'Encoding: ',sr.filesize,' bytes');
                        encoding := true;
                        Encode(sr.filesize);
                        writeln(#13,'input:  ',textsize,' bytes');
                        writeln('output: ',codesize,' bytes');
                        writeln('relative output: ',codesize*100 div textsize,'%');
                        end;
        'd','D':    begin
                        encoding := false;
                        Decode;
                        writeln(#13,Count);
                        end;
    else
        Error('! Use [D] for Decompression or [E] for Compression')
    end; {Case}
   close(infile); if Io_Result>0 then Error('! Error closing input file');
   if outptr>0 then wfbuffer;
   close(outfile); if Io_Result>0 then Error('! Error closing output file');
    get_time (h2,m2,s2);
    t1  := s1+m1*60+h1*3600;
    t2  := s2+m2*60+h2*3600;
    t3  := t2-t1;
    writeln (#13,'Elapsed time: ',t3, ' Seconds.');
if cmd_args <> 3 then begin
    close_Window(Mwindow);
    delete_Window(Mwindow);
    restr_scrn(main_screen);
    if ginitok <> -1 then exit_gem; 
    end; 
   { readln;}
end.
